PROGRAM Worm
REM (c) Starsoft 2020 Java console
REM (c) Starsoft 2022 Pascalated BASIC
REM Written by David Magalhaes
REM CLEAR variables
POKE 23739,244: REM restore messages
PRINT PAPER 5;INK 0;AT 1,13;"   Do you think   ";AT 2,13;"there will be life";AT 3,13;" in other apples?";
REM CONSTant declarations
LET true = 1
LET false = 0
REM VAR - Global variables
REM boolean GAMEOVER
REM LIN, COL
REM Direction
REM DirectionOld
REM LengthMax
REM LengthCurrent
REM TailL
REM TailC
REM Cook
REM B$ - key buffer
REM R$(8,8) automaton for PrintTrail
REM S$(8,128) automaton for getDirectionTail
REM T(128) automaton for tail colors
REM K$(128) automaton to use several keys
REM DX, DY index for automaton for moveForward
REM P(8,2) automaton for moveForward
REM m variable program loop
REM o variable game loop
REM x end pause
REM record - max length achieved
PROC main
END

DEFPROC PrintTrailOldVersion
IF DirectionOld = 5 AND Direction = 5 BEGIN w
  LET r$ = "-"
ELSEIF DirectionOld = 5 AND Direction = 6
  LET r$ = "/"
ELSEIF DirectionOld = 5 AND Direction = 7
  LET r$ = "\\"
ELSEIF DirectionOld = 6 AND Direction = 6
  LET r$ = "|"
ELSEIF DirectionOld = 6 AND Direction = 5
  LET r$ = "/"
ELSEIF DirectionOld = 6 AND Direction = 8
  LET r$ = "\\"
ELSEIF DirectionOld = 7 AND Direction = 7
  LET r$ = "|"
ELSEIF DirectionOld = 7 AND Direction = 5
  LET r$ = "\\"
ELSEIF DirectionOld = 7 AND Direction = 8
  LET r$ = "/"
ELSEIF DirectionOld = 8 AND Direction = 8
  LET r$ = "-"
ELSEIF DirectionOld = 8 AND Direction = 6
  LET r$ = "\\"
ELSEIF DirectionOld = 8 AND Direction = 7
  LET r$ = "/"
ELSE
  LET r$ = "."
ENDIF
PRINT AT LIN, COL; r$
ENDPROC

DEFPROC PrintTrail
PRINT AT LIN, COL; ink t(CODE r$(DirectionOld,Direction)); r$(DirectionOld,Direction)
ENDPROC

DEFPROC getDirectionTailOld1Version
LET c$ = SCREEN$(TailL,TailC)
IF DirectionTail = 5 AND c$ = "-" BEGIN w
  LET DirectionTail = 5
ELSEIF DirectionTail = 5 AND c$ = "/"
  LET DirectionTail = 6
ELSEIF DirectionTail = 5 AND c$ = "\\"
  LET DirectionTail = 7
ELSEIF DirectionTail = 6 AND c$ = "|"
  LET DirectionTail = 6
ELSEIF DirectionTail = 6 AND c$ = "/"
  LET DirectionTail = 5
ELSEIF DirectionTail = 6 AND c$ = "\\"
  LET DirectionTail = 8
ELSEIF DirectionTail = 7 AND c$ = "|"
  LET DirectionTail = 7
ELSEIF DirectionTail = 7 AND c$ = "/"
  LET DirectionTail = 8
ELSEIF DirectionTail = 7 AND c$ = "\\"
  LET DirectionTail = 5
ELSEIF DirectionTail = 8 AND c$ = "-"
  LET DirectionTail = 8
ELSEIF DirectionTail = 8 AND c$ = "/"
  LET DirectionTail = 7
ELSEIF DirectionTail = 8 AND c$ = "\\"
  LET DirectionTail = 6
ENDIF
ENDPROC

DEFPROC getDirectionTailOld2Version
LET c$ = SCREEN$(TailL,TailC)
LET DirectionTail = VAL s$(DirectionTail,CODE c$)
ENDPROC

DEFPROC getDirectionTail
LET c = ATTR(TailL,TailC) - 56
LET DirectionTail = VAL s$(DirectionTail, c)
ENDPROC

DEFPROC MoveForwardOldVersion
PROC PrintTrail
REM move worm
IF Direction = 8 BEGIN w
  LET COL = COL+1
ELSEIF Direction = 5
  LET COL = COL-1
ELSEIF Direction = 7
  LET LIN = LIN-1
ELSE
  LET LIN = LIN+1
ENDIF
LET c$ = SCREEN$(LIN,COL)
IF c$ = " " BEGIN w
  REM nothing ahead
  PRINT AT  LIN, COL; "o"  : REM head of worm
  PRINT #1;AT 0, 8; LengthCurrent
ELSEIF c$ >= "1" AND c$ <= "9"
  REM steped on food
  LET LengthMax = LengthMax + VAL c$
  PRINT AT  LIN, COL; "o";
ELSE
  PRINT AT  LIN, COL; "X"
  LET GAMEOVER = true
ENDIF
LET DirectionOld = Direction
REM process Tail
IF LengthCurrent < LengthMax BEGIN w
  LET LengthCurrent = LengthCurrent+1
ELSE
  PROC getDirectionTail
  PRINT AT TailL, TailC; " "
  IF DirectionTail = 6 BEGIN y
    LET TailL = TailL+1
  ELSEIF DirectionTail = 5
    LET TailC = TailC-1
  ELSEIF DirectionTail = 8
    LET TailC = TailC+1
  ELSEIF DirectionTail = 7
    LET TailL = TailL-1
  ENDIF
ENDIF
ENDPROC

DEFPROC MoveForward
PROC PrintTrail
REM move worm
LET LIN = LIN + p(Direction,DY)
LET COL = COL + p(Direction,DX)
LET c$ = SCREEN$(LIN,COL)
IF c$ = " " BEGIN w
  REM nothing ahead
  PRINT AT  LIN, COL; "o"  : REM head of worm
  PRINT #1;AT 0, 8; LengthCurrent
ELSEIF c$ >= "1" AND c$ <= "9"
  REM steped on food
  LET LengthMax = LengthMax + VAL c$
  PRINT AT  LIN, COL; "o";
ELSE
  PRINT AT  LIN, COL; "X"
  LET GAMEOVER = true
ENDIF
LET DirectionOld = Direction
REM process Tail
IF LengthCurrent < LengthMax BEGIN w
  LET LengthCurrent = LengthCurrent+1
ELSE
  PROC getDirectionTail
  PRINT AT TailL, TailC; " "
  LET TailL = TailL + p(DirectionTail,DY)
  LET TailC = TailC + p(DirectionTail,DX)
ENDIF
ENDPROC

DEFPROC GiveFood
LET cMin = 3
LET cMax = 30
LET lMin = 3
LET lMax = 20
IF Cook < 10 BEGIN w
  LET Cook = Cook+1
ELSE
  LET Cook = 0
  LET l = lMin + INT(RND * ((lMax - lMin) + 1))
  LET c = cMin + INT(RND * ((cMax - cMin) + 1))
  LET food = 1 + INT(RND * ((9 - 1) + 1))
  IF SCREEN$(l,c) = " " THEN PRINT AT l, c; food
ENDIF
ENDPROC

DEFPROC InitGame
BORDER 7: PAPER 7: INK 0: CLS
REM horizontal frame
FOR i=0 TO 31
  REM  top frame
  PRINT AT  0, i; "#";
  REM  bottom frame
  PRINT AT  21, i; "#";
NEXT i
REM vertical frame
FOR i=0 TO 21
  REM  left frame
  PRINT AT  i, 0; "#";
  REM  right frame
  PRINT AT  i, 31; "#";
NEXT i
REM Titulos
PRINT AT  0, 13; ink 1; "WORM";
PRINT #1; AT  0, 0; "Length: ";
PRINT #1; AT  1, 0; "Record: "; record
PRINT #1; AT  0, 23; "(c) 2022";AT  1, 23; "STARSOFT";
LET LIN = 10 : LET COL = 10
LET TailL = 10 : LET TailC = 10
LET Direction = 0 : LET DirectionOld = 0 : REM must init with first move
LET Cook= 0
LET B$ = ""
PRINT AT LIN, COL; "o" : REM head of worm
LET LengthMax = 2 : LET LengthCurrent = 1
REM PRINT AT  1, 10; LengthCurrent
PRINT #1;AT 0, 8; LengthCurrent
LET GAMEOVER = false
ENDPROC

DEFPROC InitProg
REM CLS: PRINT AT 18,5;"Please wait..."
LET record = 0
PROC DefineChars
REM automaton for PrintTrail
DIM r$(8,8)
LET r$(5,5) = "\A" : REM "-"
LET r$(5,6) = "\F" : REM "/"
LET r$(5,7) = "\C" : REM "\\"
LET r$(6,6) = "\B" : REM "|"
LET r$(6,5) = "\D" : REM "/"
LET r$(6,8) = "\C" : REM "\\"
LET r$(7,7) = "\B" : REM "|"
LET r$(7,5) = "\E" : REM "\\"
LET r$(7,8) = "\F" : REM "/"
LET r$(8,8) = "\A" : REM "-"
LET r$(8,6) = "\E" : REM "\\"
LET r$(8,7) = "\D" : REM "/"
REM automaton for getDirectionTail
DIM s$(8,4)
LET s$(5,1) = "5"
LET s$(5,3) = "7"
LET s$(5,4) = "6"
LET s$(6,2) = "6"
LET s$(6,3) = "8"
LET s$(6,4) = "5"
LET s$(7,2) = "7"
LET s$(7,3) = "5"
LET s$(7,4) = "8"
LET s$(8,1) = "8"
LET s$(8,3) = "6"
LET s$(8,4) = "7"
REM automaton for moveForward
DIM p(8,2)
LET DX = 1 : LET DY = 2
LET p(5,DX) = -1 : LET p(5,DY) = 0
LET p(6,DX) = 0 : LET p(6,DY) = 1
LET p(7,DX) = 0 : LET p(7,DY) = -1
LET p(8,DX) = 1 : LET p(8,DY) = 0
REM automaton for tail colors
DIM t(150)
LET t(CODE("\A")) = 1
LET t(CODE("\B")) = 2
LET t(CODE("\C")) = 3
LET t(CODE("\D")) = 4
LET t(CODE("\E")) = 3
LET t(CODE("\F")) = 4
REM Table for accept 5678 qaop and arrows
DIM k$(128)
REM left
LET k$(CODE "5") = "5"
LET k$(CODE "o") = "5"
LET k$(CODE "O") = "5"
LET k$(8) = "5" : REM arrow
REM right
LET k$(CODE "8") = "8"
LET k$(CODE "p") = "8"
LET k$(CODE "P") = "8"
LET k$(9) = "8" : REM arrow
REM up
LET k$(CODE "7") = "7"
LET k$(CODE "q") = "7"
LET k$(CODE "Q") = "7"
LET k$(11) = "7" : REM arrow
REM down
LET k$(CODE "6") = "6"
LET k$(CODE "a") = "6"
LET k$(CODE "A") = "6"
LET k$(10) = "6" : REM arrow
ENDPROC

DEFPROC WaitForPlayer
PRINT AT 18,5;"Keys: 5678 QAOP arrows"
PRINT AT 19,3;"  PRESS ANY KEY TO START  "
REPEAT x
  PAUSE 0
  LET B$ = k$(CODE (INKEY$+" ") )
UNTIL B$ >= "5" AND B$ <= "8"
LET Direction = VAL B$
LET DirectionOld = Direction
LET DirectionTail = Direction
PRINT AT 18,5;"                      "
PRINT AT 19,5;"                      "
ENDPROC

DEFPROC game
PROC InitGame
PROC WaitForPlayer
REPEAT o
  LET B$ = k$(CODE (INKEY$+" ") )
  IF B$ >= "5" AND B$ <= "8" THEN  IF Direction + VAL B$ <> 13 THEN LET Direction = VAL B$
  PROC MoveForward
  PROC GiveFood
UNTIL GAMEOVER
PROC TheEnd
ENDPROC

DEFPROC main
PROC InitProg
REPEAT m
  PROC game
UNTIL false
ENDPROC

DEFPROC TheEnd
PRINT AT 21,10; ink 2; " GAME OVER "
IF LengthCurrent > record BEGIN z
  PRINT AT 0,8; ink 2; " NEW HIGH SCORE "
  LET record = LengthCurrent
ENDIF
REPEAT x
UNTIL  INKEY$ = ""
FOR i=1 TO 5
  PAUSE 50
NEXT i
ENDPROC

DEFPROC DefineChars
RESTORE DataChars
READ b$
REPEAT w
  FOR i=0 TO 7
    READ n
    POKE USR b$+i,n
  NEXT i
  READ b$
UNTIL b$ = ""
ENDPROC

DEFPROC DataChars
DATA "A"
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 11111111
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA "B"
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010000
DATA "C"
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00011111
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA "D"
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 11110000
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA "E"
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 11110000
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010000
DATA "F"
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00011111
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010000
DATA ""
ENDPROC
